<template>
  <crud-data-table-delete
    v-model="dialog"
    :entity-being-deleted="$t('paymentMethod')"
    :item-being-deleted="paymentMethodBeingDeleted"
    :loading="isLoading"
    @onAgree="onAgree"
    @onDisagree="onDisagree"
  />
</template>

<script>
  export default {
    name: 'DeletePaymentMethodDialog',
    data () {
      return {
        dialog: false,
        isLoading: false,
        paymentMethodBeingDeleted: {},
      }
    },
    created () {
      this.$emit('onDeletePaymentMethod', this.onDeletePaymentMethod)
    },
    methods: {
      onDeletePaymentMethod (paymentMethod) {
        this.paymentMethodBeingDeleted = paymentMethod
        this.dialog = true
      },
      onAgree () {
        this.isLoading = true
        this.$store.dispatch('paymentMethods/deletePaymentMethod', {
          ID: this.paymentMethodBeingDeleted.id,
        })
          .then(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'success',
              text: this.$t('deleteSuccess'),
            })
          })
          .catch(() => {
            this.$store.dispatch('toast/setOptions', {
              variant: 'error',
              text: this.$t('deleteError'),
            })
          })
          .finally(() => {
            this.dialog = false
            this.isLoading = false
          })
      },
      onDisagree () {
        this.dialog = false
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          paymentMethod: 'Via de pagamento',
          deleteSuccess: 'Via de pagamento excluída com sucesso!',
          deleteError: 'Ops... Algo deu errado ao tentar excluir a via de pagamento. Por favor, tente novamente.',
        },
        'en-US': {
          paymentMethod: 'Payment method',
          deleteSuccess: 'Payment method successfully deleted!',
          deleteError: 'Oops... Something went wrong while trying to delete the payment method. Please try again.',
        },
      },
    },
  }
</script>
